
-- Status: 21.07.2016

-----------------------
--- ANALYZE SO-URLS ---
-----------------------

-- total number of references
SELECT COUNT(*)
FROM [snippets.c];

=> 84660

-------------------------------------------------------------------------
----------------------------------------------
--- C-specific (header vs. implementation) ---
----------------------------------------------
SELECT COUNT(*)
FROM [snippets.c_file_ext]
WHERE file_ext = ".c";

=> 7483

SELECT COUNT(*)
FROM [snippets.c_file_ext]
WHERE file_ext = ".cpp"
  OR file_ext = ".cc"
  OR file_ext = ".cxx"
  OR file_ext = ".c++";
 
=> 27103

SELECT COUNT(*)
FROM [snippets.c_file_ext]
WHERE file_ext = ".h"
  OR file_ext = ".hh"
  OR file_ext = ".hpp"
  OR file_ext =  ".hxx"
  OR file_ext =  ".h++";

=> 50074
-------------------------------------------------------------------------

-- number of references to answers or questions
SELECT COUNT(*)
FROM [snippets.c_a_q];

=> 84343

-- number of distinct files with reference to answer or question
SELECT COUNT(*)
FROM (
  SELECT id
  FROM [snippets.c_a_q_distinct_url_file]
  GROUP BY id
);

=> 17474

-------------------------------------------------------------------------
----------------------------------------------
--- C-specific (header vs. implementation) ---
----------------------------------------------
SELECT COUNT(*)
FROM (
  SELECT id
  FROM [snippets.c_a_q_distinct_url_file_file_ext]
  WHERE file_ext = ".c"
  GROUP BY id
);

=> 2542

SELECT COUNT(*)
FROM (
  SELECT id
  FROM [snippets.c_a_q_distinct_url_file_file_ext]
  WHERE file_ext = ".cpp"
    OR file_ext = ".cc"
    OR file_ext = ".cxx"
    OR file_ext = ".c++"
  GROUP BY id
);

=> 9369

SELECT COUNT(*)
FROM (
  SELECT id
  FROM [snippets.c_a_q_distinct_url_file_file_ext]
  WHERE file_ext = ".h"
    OR file_ext = ".hh"
    OR file_ext = ".hpp"
    OR file_ext =  ".hxx"
    OR file_ext =  ".h++"
  GROUP BY id
);

=> 5563

-------------------------------------------------------------------------

-- number of distinct references to threads
SELECT COUNT(*)
FROM [snippets.c_q_distinct_url_file];

=> 19873

-- number of distinct referenced threads
SELECT COUNT(*)
FROM (
  SELECT url
  FROM [snippets.c_q_distinct_url_file]
  GROUP BY url
);

=> 5927

-------------------------------------------------------------------------
----------------------------------------------
--- C-specific (header vs. implementation) ---
----------------------------------------------
SELECT COUNT(*)
FROM [snippets.c_q_distinct_url_file_file_ext]
WHERE file_ext = ".c";

=> 2825

SELECT COUNT(*)
FROM (
  SELECT url
  FROM [snippets.c_q_distinct_url_file_file_ext]
  WHERE file_ext = ".c"
  GROUP BY url
);

=> 1284

SELECT COUNT(*)
FROM [snippets.c_q_distinct_url_file_file_ext]
WHERE file_ext = ".cpp"
    OR file_ext = ".cc"
    OR file_ext = ".cxx"
    OR file_ext = ".c++";

=> 10281

SELECT COUNT(*)
FROM (
  SELECT url
  FROM [snippets.c_q_distinct_url_file_file_ext]
  WHERE file_ext = ".cpp"
    OR file_ext = ".cc"
    OR file_ext = ".cxx"
    OR file_ext = ".c++"
  GROUP BY url
);

=> 2748

SELECT COUNT(*)
FROM [snippets.c_q_distinct_url_file_file_ext]
WHERE file_ext = ".h"
    OR file_ext = ".hh"
    OR file_ext = ".hpp"
    OR file_ext =  ".hxx"
    OR file_ext =  ".h++";

=> 6767

SELECT COUNT(*)
FROM (
  SELECT url
  FROM [snippets.c_q_distinct_url_file_file_ext]
  WHERE file_ext = ".h"
    OR file_ext = ".hh"
    OR file_ext = ".hpp"
    OR file_ext =  ".hxx"
    OR file_ext =  ".h++"
  GROUP BY url
);

=> 2709

-------------------------------------------------------------------------


-- number of references to answers
SELECT COUNT(*)
FROM [snippets.c_a_q]
WHERE
  REGEXP_MATCH(url, r'(https?:\/\/stackoverflow\.com\/a\/[\d]+)');
  
=> 36006

-------------------------------------------------------------------------
----------------------------------------------
--- C-specific (header vs. implementation) ---
----------------------------------------------
SELECT COUNT(*)
FROM [snippets.c_file_ext]
WHERE
  REGEXP_MATCH(url, r'(https?:\/\/stackoverflow\.com\/a\/[\d]+)')
  AND file_ext = ".c";

=> 1583

SELECT COUNT(*)
FROM [snippets.c_file_ext]
WHERE
  REGEXP_MATCH(url, r'(https?:\/\/stackoverflow\.com\/a\/[\d]+)')
  AND (file_ext = ".cpp"
    OR file_ext = ".cc"
    OR file_ext = ".cxx"
    OR file_ext = ".c++");
 
=> 5255

SELECT COUNT(*)
FROM [snippets.c_file_ext]
WHERE
  REGEXP_MATCH(url, r'(https?:\/\/stackoverflow\.com\/a\/[\d]+)')
  AND (file_ext = ".h"
    OR file_ext = ".hh"
    OR file_ext = ".hpp"
    OR file_ext =  ".hxx"
    OR file_ext =  ".h++");

=> 29168
-------------------------------------------------------------------------

-- number of references to questions
SELECT COUNT(*)
FROM [snippets.c_a_q]
WHERE
  REGEXP_MATCH(url, r'(https?:\/\/stackoverflow\.com\/q\/[\d]+)');
  
=> 48337

-------------------------------------------------------------------------
----------------------------------------------
--- C-specific (header vs. implementation) ---
----------------------------------------------
SELECT COUNT(*)
FROM [snippets.c_file_ext]
WHERE
  REGEXP_MATCH(url, r'(https?:\/\/stackoverflow\.com\/q\/[\d]+)')
  AND file_ext = ".c";

=> 5880

SELECT COUNT(*)
FROM [snippets.c_file_ext]
WHERE
  REGEXP_MATCH(url, r'(https?:\/\/stackoverflow\.com\/q\/[\d]+)')
  AND (file_ext = ".cpp"
    OR file_ext = ".cc"
    OR file_ext = ".cxx"
    OR file_ext = ".c++");
 
=> 21780

SELECT COUNT(*)
FROM [snippets.c_file_ext]
WHERE
  REGEXP_MATCH(url, r'(https?:\/\/stackoverflow\.com\/q\/[\d]+)')
  AND (file_ext = ".h"
    OR file_ext = ".hh"
    OR file_ext = ".hpp"
    OR file_ext =  ".hxx"
    OR file_ext =  ".h++");

=> 20677
-------------------------------------------------------------------------

-- number of other references
SELECT COUNT(*)
FROM [snippets.c_other];
   
=> 317

-------------------------------------------------------------------------

-- number of distinct references to answers or questions (counting only distinct urls per file)
SELECT COUNT(*)
FROM [snippets.c_a_q_distinct_url_file];

=> 19920


-------------------------------------------------------------------------
----------------------------------------------
--- C-specific (header vs. implementation) ---
----------------------------------------------
SELECT COUNT(*)
FROM [snippets.c_a_q_distinct_url_file_file_ext]
WHERE file_ext = ".c";

=> 2836

SELECT COUNT(*)
FROM [snippets.c_a_q_distinct_url_file_file_ext]
WHERE file_ext = ".cpp"
  OR file_ext = ".cc"
  OR file_ext = ".cxx"
  OR file_ext = ".c++";
 
=> 10298

SELECT COUNT(*)
FROM [snippets.c_a_q_distinct_url_file_file_ext]
WHERE file_ext = ".h"
  OR file_ext = ".hh"
  OR file_ext = ".hpp"
  OR file_ext =  ".hxx"
  OR file_ext =  ".h++";

=> 6786
-------------------------------------------------------------------------


-- number of distinct references to answers
SELECT COUNT(*)
FROM [snippets.c_a_q_distinct_url_file]
WHERE
  REGEXP_MATCH(url, r'(https?:\/\/stackoverflow\.com\/a\/[\d]+)');

=> 3695

-------------------------------------------------------------------------
----------------------------------------------
--- C-specific (header vs. implementation) ---
----------------------------------------------
SELECT COUNT(*)
FROM [snippets.c_a_q_distinct_url_file_file_ext]
WHERE
  REGEXP_MATCH(url, r'(https?:\/\/stackoverflow\.com\/a\/[\d]+)')
  AND file_ext = ".c";

=> 613

SELECT COUNT(*)
FROM [snippets.c_a_q_distinct_url_file_file_ext]
WHERE
  REGEXP_MATCH(url, r'(https?:\/\/stackoverflow\.com\/a\/[\d]+)')
  AND (file_ext = ".cpp"
  	OR file_ext = ".cc"
  	OR file_ext = ".cxx"
  	OR file_ext = ".c++");
 
=> 1301

SELECT COUNT(*)
FROM [snippets.c_a_q_distinct_url_file_file_ext]
WHERE
  REGEXP_MATCH(url, r'(https?:\/\/stackoverflow\.com\/a\/[\d]+)')
  AND (file_ext = ".h"
  	OR file_ext = ".hh"
  	OR file_ext = ".hpp"
  	OR file_ext =  ".hxx"
  	OR file_ext =  ".h++");

=> 1781
-------------------------------------------------------------------------


-- number of distinct references to questions
SELECT COUNT(*)
FROM [snippets.c_a_q_distinct_url_file]
WHERE
  REGEXP_MATCH(url, r'(https?:\/\/stackoverflow\.com\/q\/[\d]+)');

=> 16225

-------------------------------------------------------------------------
----------------------------------------------
--- C-specific (header vs. implementation) ---
----------------------------------------------
SELECT COUNT(*)
FROM [snippets.c_a_q_distinct_url_file_file_ext]
WHERE
  REGEXP_MATCH(url, r'(https?:\/\/stackoverflow\.com\/q\/[\d]+)')
  AND file_ext = ".c";

=> 2223

SELECT COUNT(*)
FROM [snippets.c_a_q_distinct_url_file_file_ext]
WHERE
  REGEXP_MATCH(url, r'(https?:\/\/stackoverflow\.com\/q\/[\d]+)')
  AND (file_ext = ".cpp"
  	OR file_ext = ".cc"
  	OR file_ext = ".cxx"
  	OR file_ext = ".c++");
 
=> 8997

SELECT COUNT(*)
FROM [snippets.c_a_q_distinct_url_file_file_ext]
WHERE
  REGEXP_MATCH(url, r'(https?:\/\/stackoverflow\.com\/q\/[\d]+)')
  AND (file_ext = ".h"
  	OR file_ext = ".hh"
  	OR file_ext = ".hpp"
  	OR file_ext =  ".hxx"
  	OR file_ext =  ".h++");

=> 5005
-------------------------------------------------------------------------

-- number of distinct references to other urls
SELECT COUNT(*)
FROM (
  SELECT id, url
  FROM [snippets.c_other]
  GROUP BY id, url
);

=> 121

-------------------------------------------------------------------------
----------------------------------------------
--- C-specific (header vs. implementation) ---
----------------------------------------------
SELECT COUNT(*)
FROM [snippets.c_other_distinct_url_file_file_ext]
WHERE
  file_ext = ".c";

=> 16

SELECT COUNT(*)
FROM [snippets.c_other_distinct_url_file_file_ext]
WHERE
  file_ext = ".cpp"
  	OR file_ext = ".cc"
  	OR file_ext = ".cxx"
  	OR file_ext = ".c++";
 
=> 35

SELECT COUNT(*)
FROM [snippets.c_other_distinct_url_file_file_ext]
WHERE
  file_ext = ".h"
  	OR file_ext = ".hh"
  	OR file_ext = ".hpp"
  	OR file_ext =  ".hxx"
  	OR file_ext =  ".h++";

=> 70
-------------------------------------------------------------------------
 
-- number of distinct URLS
SELECT COUNT(*)
FROM (
  SELECT url
  FROM [snippets.c]
  GROUP BY url
);

=> 6645

-------------------------------------------------------------------------
----------------------------------------------
--- C-specific (header vs. implementation) ---
----------------------------------------------
SELECT COUNT(*)
FROM (
  SELECT url
  FROM [snippets.c_file_ext]
  WHERE file_ext = ".c"
  GROUP BY url
);

=> 1399

SELECT COUNT(*)
FROM (
  SELECT url
  FROM [snippets.c_file_ext]
  WHERE file_ext = ".cpp"
  	OR file_ext = ".cc"
  	OR file_ext = ".cxx"
  	OR file_ext = ".c++"
  GROUP BY url
);

=> 2988

SELECT COUNT(*)
FROM (
  SELECT url
  FROM [snippets.c_file_ext]
  WHERE file_ext = ".h"
  	OR file_ext = ".hh"
  	OR file_ext = ".hpp"
  	OR file_ext =  ".hxx"
  	OR file_ext =  ".h++"
  GROUP BY url
);

=> 3038
-------------------------------------------------------------------------

-- number of distinct answer URLS
SELECT COUNT(*)
FROM (
  SELECT url
  FROM [snippets.c_a_q]
  WHERE REGEXP_MATCH(url, r'(https?:\/\/stackoverflow\.com\/a\/[\d]+)')
  GROUP BY url
);

=> 1609

-------------------------------------------------------------------------
----------------------------------------------
--- C-specific (header vs. implementation) ---
----------------------------------------------
SELECT COUNT(*)
FROM (
  SELECT url
  FROM [snippets.c_file_ext]
  WHERE REGEXP_MATCH(url, r'(https?:\/\/stackoverflow\.com\/a\/[\d]+)')
  	AND file_ext = ".c"
  GROUP BY url
);

=> 326

SELECT COUNT(*)
FROM (
  SELECT url
  FROM [snippets.c_file_ext]
  WHERE REGEXP_MATCH(url, r'(https?:\/\/stackoverflow\.com\/a\/[\d]+)')
    AND (file_ext = ".cpp"
  	  OR file_ext = ".cc"
  	  OR file_ext = ".cxx"
  	  OR file_ext = ".c++")
  GROUP BY url
);

=> 625

SELECT COUNT(*)
FROM (
  SELECT url
  FROM [snippets.c_file_ext]
  WHERE REGEXP_MATCH(url, r'(https?:\/\/stackoverflow\.com\/a\/[\d]+)')
    AND (file_ext = ".h"
  	  OR file_ext = ".hh"
  	  OR file_ext = ".hpp"
  	  OR file_ext =  ".hxx"
  	  OR file_ext =  ".h++")
  GROUP BY url
);

=> 825
-------------------------------------------------------------------------

-- number of distinct question URLS
SELECT COUNT(*)
FROM (
  SELECT url
  FROM [snippets.c_a_q]
  WHERE REGEXP_MATCH(url, r'(https?:\/\/stackoverflow\.com\/q\/[\d]+)')
  GROUP BY url
);

=> 4960

-------------------------------------------------------------------------
----------------------------------------------
--- C-specific (header vs. implementation) ---
----------------------------------------------
SELECT COUNT(*)
FROM (
  SELECT url
  FROM [snippets.c_file_ext]
  WHERE REGEXP_MATCH(url, r'(https?:\/\/stackoverflow\.com\/q\/[\d]+)')
  	AND file_ext = ".c"
  GROUP BY url
);

=> 1059

SELECT COUNT(*)
FROM (
  SELECT url
  FROM [snippets.c_file_ext]
  WHERE REGEXP_MATCH(url, r'(https?:\/\/stackoverflow\.com\/q\/[\d]+)')
    AND (file_ext = ".cpp"
  	  OR file_ext = ".cc"
  	  OR file_ext = ".cxx"
  	  OR file_ext = ".c++")
  GROUP BY url
);

=> 2335

SELECT COUNT(*)
FROM (
  SELECT url
  FROM [snippets.c_file_ext]
  WHERE REGEXP_MATCH(url, r'(https?:\/\/stackoverflow\.com\/q\/[\d]+)')
    AND (file_ext = ".h"
  	  OR file_ext = ".hh"
  	  OR file_ext = ".hpp"
  	  OR file_ext =  ".hxx"
  	  OR file_ext =  ".h++")
  GROUP BY url
);

=> 2167
-------------------------------------------------------------------------

-- number of distinct other URLS
SELECT COUNT(*)
FROM (
  SELECT url
  FROM [snippets.c_other]
  GROUP BY url
);

=> 76

-- analyze other references
SELECT *
FROM [snippets.c_other]
WHERE
  NOT REGEXP_MATCH(url, r'(https?:\/\/stackoverflow\.com\/users\/[^\s]*)') -- links to users
  AND NOT REGEXP_MATCH(url, r'(https?:\/\/stackoverflow\.com\/(?:questions\/)?(?:tags|tagged)\/[^\s]*)') -- links to tags
  AND NOT REGEXP_MATCH(url, r'(https?:\/\/stackoverflow\.com\/search\?[^\s]*)') -- links to SO search
  AND NOT REGEXP_MATCH(url, r'(https?:\/\/stackoverflow\.com\/feeds\/[^\s]*)') -- links to RSS feed
  AND NOT REGEXP_MATCH(url, r'(https?:\/\/stackoverflow\.com\/posts\/[^\s]*)') -- links to revision of post
  AND NOT REGEXP_MATCH(url, r'(https?:\/\/stackoverflow\.com\/(?:q|questions)\/?[^\s]*)') -- possibly line break
  AND NOT REGEXP_MATCH(url, r'(https?:\/\/stackoverflow\.com\/?$)'); -- links to SO root

-------------------------------------------------------------------------

-- analyze mapped questions
SELECT COUNT(*)
FROM (
  SELECT url
  FROM [snippets.c_q_distinct_url_file_file_ext]
  WHERE file_ext=".c"
  GROUP BY url
);

=> 1284

SELECT COUNT(*)
FROM (
  SELECT url
  FROM [snippets.c_q_distinct_url_file_file_ext]
  WHERE file_ext = ".cpp"
  	OR file_ext = ".cc"
  	OR file_ext = ".cxx"
  	OR file_ext = ".c++"
  GROUP BY url
);

=> 2748

SELECT COUNT(*)
FROM (
  SELECT url
  FROM [snippets.c_q_distinct_url_file_file_ext]
  WHERE file_ext = ".h"
  	  OR file_ext = ".hh"
  	  OR file_ext = ".hpp"
  	  OR file_ext =  ".hxx"
  	  OR file_ext =  ".h++"
  GROUP BY url
);

=> 2709

----------------------------------------------------------------------------------------------

-- 25.08.2016

-- repos with reference to answer or question
SELECT COUNT(*)
FROM (
  SELECT repo_name
  FROM [snippets.c_a_q_distinct_url_file]
  GROUP BY repo_name
);

=> 12062

SELECT COUNT(*)
FROM (
  SELECT repo_name
  FROM [snippets.c_a_q_distinct_url_file_file_ext]
  WHERE file_ext=".c"
  GROUP BY repo_name
);

=> 1980

-- total number of repos containing c files
SELECT COUNT(*)
FROM (
  SELECT repo_name
  FROM [snippets.repos_file_ext]
  WHERE file_ext=".c"
  GROUP BY repo_name
);

=> 237902

SELECT COUNT(*)
FROM (
  SELECT repo_name
  FROM [snippets.c_a_q_distinct_url_file_file_ext]
  WHERE file_ext = ".cpp"
  OR file_ext = ".cc"
  OR file_ext = ".cxx"
  OR file_ext = ".c++"
  GROUP BY repo_name
);

=> 7173

SELECT COUNT(*)
FROM (
  SELECT repo_name
  FROM [snippets.repos_file_ext]
  WHERE file_ext = ".cpp"
  OR file_ext = ".cc"
  OR file_ext = ".cxx"
  OR file_ext = ".c++"
  GROUP BY repo_name
);

=> 220838

SELECT COUNT(*)
FROM (
  SELECT repo_name
  FROM [snippets.c_a_q_distinct_url_file_file_ext]
  WHERE file_ext = ".h"
  OR file_ext = ".hh"
  OR file_ext = ".hpp"
  OR file_ext =  ".hxx"
  OR file_ext =  ".h++"
  GROUP BY repo_name
);

=> 3998

SELECT COUNT(*)
FROM (
  SELECT repo_name
  FROM [snippets.repos_file_ext]
  WHERE file_ext = ".h"
  OR file_ext = ".hh"
  OR file_ext = ".hpp"
  OR file_ext =  ".hxx"
  OR file_ext =  ".h++"
  GROUP BY repo_name
);

=> 395120
