
-- Status: 20.07.2016

--------------------------------------------------------------------------
--- GET NUMBER OF DISTINCT FILES AND NUMBER OF DISTINCT LINES PER URL ----
--------------------------------------------------------------------------

---- js_a_q ----
SELECT
  lc.url as url,
  lc.line_count as line_count,
  fc.file_count as file_count
FROM (
  SELECT
    url,
    COUNT(line) as line_count,
  FROM
    [snippets.js_a_q_distinct_url_line]
  GROUP BY url
) as lc
JOIN (
  SELECT
    url,
    COUNT(id) as file_count,
  FROM
    [snippets.js_a_q_distinct_url_file]
  GROUP BY url
) as fc
ON fc.url = lc.url
ORDER BY line_count DESC, file_count DESC;
  
=> js_a_q_count_distinct_line_file_per_url
  
---- js_q ----
SELECT
  lc.url as url,
  lc.line_count as line_count,
  fc.file_count as file_count
FROM (
  SELECT
    url,
    COUNT(line) as line_count,
  FROM
    [snippets.js_q_distinct_url_line]
  GROUP BY url
) as lc
JOIN (
  SELECT
    url,
    COUNT(id) as file_count,
  FROM
    [snippets.js_q_distinct_url_file]
  GROUP BY url
) as fc
ON fc.url = lc.url
ORDER BY line_count DESC, file_count DESC;

=> js_q_count_distinct_line_file_per_url

---- js_a ----
SELECT
  lc.url as url,
  lc.line_count as line_count,
  fc.file_count as file_count
FROM (
  SELECT
    url,
    COUNT(line) as line_count,
  FROM
    [snippets.js_a_q_distinct_url_line]
  WHERE
    REGEXP_MATCH(url, r'(http:\/\/stackoverflow\.com\/a\/[\d]+)')
  GROUP BY url
) as lc
JOIN (
  SELECT
    url,
    COUNT(id) as file_count,
  FROM
    [snippets.js_a_q_distinct_url_file]
  WHERE
    REGEXP_MATCH(url, r'(http:\/\/stackoverflow\.com\/a\/[\d]+)')
  GROUP BY url
) as fc
ON fc.url = lc.url
ORDER BY line_count DESC, file_count DESC;

=> js_a_count_distinct_line_file_per_url


----------------------------------------------------------
--- GET NUMBER OF DISTINCT SO-URLS AND LINES PER FILE ----
----------------------------------------------------------
---- js_a_q ----
SELECT
  uc.id as id,
  uc.url_count as url_count,
  lc.line_count as line_count
FROM (
  SELECT
    id,
    COUNT(url) as url_count
  FROM
    [snippets.js_a_q_distinct_url_file]
  GROUP BY id
) as uc
JOIN (
  SELECT
    id,
    COUNT(line) as line_count
  FROM (
    SELECT
      id, line
    FROM
      [snippets.js_a_q]
    GROUP BY
      id, line
)
GROUP BY id
ORDER BY line_count DESC 
) as lc
ON uc.id = lc.id
ORDER BY url_count DESC, line_count DESC;
  
=> js_a_q_count_distinct_url_line_per_file

