LANGUAGE=c("r")  # java / c / cs / js / / php / py / r

#setwd(paste("/Users/Sebastian/git/kiefer/bigquery/", LANGUAGE, "/", sep=""))
setwd(paste("E:/Git/kiefer/bigquery/", LANGUAGE, "/", sep=""))

# read question urls
data <- read.csv(file=paste("data/r/", LANGUAGE, "_a_export.csv", sep=""), header=TRUE, sep=",", quote="\"", na.strings=c(""), stringsAsFactors=FALSE)
answer_urls <- data$url

# retrieve corresponding questions
library(httr)
question_urls <- unlist(lapply(answer_urls, function(x) {
  resp <- GET(x)
  resp$url
}))

# reformat question URLs
library(stringr)
question_urls <- str_extract(question_urls, "http://stackoverflow.com/questions/[^/]+")
question_urls <- str_replace(question_urls, "questions", "q")

# create mapping from answer to question URLs
a_q_mapping <- as.data.frame(cbind(answer_urls, question_urls), stringsAsFactors=FALSE)
names(a_q_mapping) <- c("url_a", "url_q")

# write mapping to CSV file
write.table(a_q_mapping, file = paste("data/r/", LANGUAGE, "_a_q_mapping.csv", sep=""), sep=",", col.names=TRUE, row.names=FALSE, na="", quote=FALSE)
